coap_context_t Struct Reference

The CoAP stack's global state is stored in a coap_context_t object. More...

`#include <net.h>`

Collaboration diagram for coap_context_t:
[legend]

## Data Fields

coap_opt_filter_t | known_options
struct coap_resource_t * | resources
| hash table or list of known resources More...
struct coap_resource_t * | unknown_resource
| can be used for handling unknown resources More...
struct coap_async_state_t * | async_state
| list of asynchronous transactions More...
coap_tick_t | sendqueue_basetime
| The time stamp in the first element of the sendqeue is relative to sendqueue_basetime. More...
coap_queue_t * | sendqueue
coap_endpoint_t * | endpoint
| the endpoints used for listening More...
coap_session_t * | sessions
| client sessions More...
coap_response_handler_t | response_handler
coap_nack_handler_t | nack_handler
coap_ping_handler_t | ping_handler
coap_pong_handler_t | pong_handler
coap_event_handler_t | handle_event
| Callback function that is used to signal events to the application. More...
ssize_t(* | network_send )(coap_socket_t *sock, const coap_session_t *session, const uint8_t *data, size_t datalen)
ssize_t(* | network_read )(coap_socket_t *sock, struct coap_packet_t *packet)
size_t(* | get_client_psk )(const coap_session_t *session, const uint8_t *hint, size_t hint_len, uint8_t *identity, size_t *identity_len, size_t max_identity_len, uint8_t *psk, size_t max_psk_len)
size_t(* | get_server_psk )(const coap_session_t *session, const uint8_t *identity, size_t identity_len, uint8_t *psk, size_t max_psk_len)
size_t(* | get_server_hint )(const coap_session_t *session, uint8_t *hint, size_t max_hint_len)
void * | dtls_context
uint8_t * | psk_hint
size_t | psk_hint_len
uint8_t * | psk_key
size_t | psk_key_len
unsigned int | session_timeout
| Number of seconds of inactivity after which an unused session will be closed. More...
unsigned int | max_idle_sessions
| Maximum number of simultaneous unused sessions per endpoint. More...
unsigned int | max_handshake_sessions
| Maximum number of simultaneous negotating sessions per endpoint. More...
unsigned int | ping_timeout
| Minimum inactivity time before sending a ping message. More...
unsigned int | csm_timeout
| Timeout for waiting for a CSM from the remote side. More...
void * | app
| application-specific data More...

## Detailed Description

The CoAP stack's global state is stored in a coap_context_t object.

Definition at line 147 of file net.h.

## Field Documentation

## app

void* coap_context_t::app

application-specific data

Definition at line 211 of file net.h.

## async_state

struct coap_async_state_t* coap_context_t::async_state

list of asynchronous transactions

Definition at line 157 of file net.h.

## csm_timeout

unsigned int coap_context_t::csm_timeout

Timeout for waiting for a CSM from the remote side.

0 means disabled.

Definition at line 209 of file net.h.

## dtls_context

void* coap_context_t::dtls_context

Definition at line 199 of file net.h.

## endpoint

coap_endpoint_t* coap_context_t::endpoint

the endpoints used for listening

Definition at line 165 of file net.h.

## get_client_psk

size_t(* coap_context_t::get_client_psk) (const coap_session_t *session, const uint8_t *hint, size_t hint_len, uint8_t *identity, size_t *identity_len, size_t max_identity_len, uint8_t *psk, size_t max_psk_len)

Definition at line 195 of file net.h.

## get_server_hint

size_t(* coap_context_t::get_server_hint) (const coap_session_t *session, uint8_t *hint, size_t max_hint_len)

Definition at line 197 of file net.h.

## get_server_psk

size_t(* coap_context_t::get_server_psk) (const coap_session_t *session, const uint8_t *identity, size_t identity_len, uint8_t *psk, size_t max_psk_len)

Definition at line 196 of file net.h.

## handle_event

coap_event_handler_t coap_context_t::handle_event

Callback function that is used to signal events to the application.

This field is set by coap_set_event_handler().

Definition at line 189 of file net.h.

## known_options

coap_opt_filter_t coap_context_t::known_options

Definition at line 148 of file net.h.

## max_handshake_sessions

unsigned int coap_context_t::max_handshake_sessions

Maximum number of simultaneous negotating sessions per endpoint.

0 means use default.

Definition at line 207 of file net.h.

## max_idle_sessions

unsigned int coap_context_t::max_idle_sessions

Maximum number of simultaneous unused sessions per endpoint.

0 means no maximum.

Definition at line 206 of file net.h.

## nack_handler

coap_nack_handler_t coap_context_t::nack_handler

Definition at line 181 of file net.h.

## network_read

ssize_t(* coap_context_t::network_read) (coap_socket_t *sock, struct coap_packet_t *packet)

Definition at line 193 of file net.h.

## network_send

ssize_t(* coap_context_t::network_send) (coap_socket_t *sock, const coap_session_t *session, const uint8_t *data, size_t datalen)

Definition at line 191 of file net.h.

## ping_handler

coap_ping_handler_t coap_context_t::ping_handler

Definition at line 182 of file net.h.

## ping_timeout

unsigned int coap_context_t::ping_timeout

Minimum inactivity time before sending a ping message.

0 means disabled.

Definition at line 208 of file net.h.

## pong_handler

coap_pong_handler_t coap_context_t::pong_handler

Definition at line 183 of file net.h.

## psk_hint

uint8_t* coap_context_t::psk_hint

Definition at line 200 of file net.h.

## psk_hint_len

size_t coap_context_t::psk_hint_len

Definition at line 201 of file net.h.

## psk_key

uint8_t* coap_context_t::psk_key

Definition at line 202 of file net.h.

## psk_key_len

size_t coap_context_t::psk_key_len

Definition at line 203 of file net.h.

## resources

struct coap_resource_t* coap_context_t::resources

hash table or list of known resources

Definition at line 149 of file net.h.

## response_handler

coap_response_handler_t coap_context_t::response_handler

Definition at line 180 of file net.h.

## sendqueue

coap_queue_t* coap_context_t::sendqueue

Definition at line 164 of file net.h.

## sendqueue_basetime

coap_tick_t coap_context_t::sendqueue_basetime

The time stamp in the first element of the sendqeue is relative to sendqueue_basetime.

Definition at line 163 of file net.h.

## session_timeout

unsigned int coap_context_t::session_timeout

Number of seconds of inactivity after which an unused session will be closed.

0 means use default.

Definition at line 205 of file net.h.

## sessions

coap_session_t* coap_context_t::sessions

client sessions

Definition at line 166 of file net.h.

## unknown_resource

struct coap_resource_t* coap_context_t::unknown_resource

can be used for handling unknown resources

Definition at line 151 of file net.h.

The documentation for this struct was generated from the following file:

- net.h